<?php
namespace app\admin\controller;

use app\common\controller\Admin;

class Apply extends Admin
{

    //应用打包
	public function create()
    {
		return $this->fetch();
	}
    
    //应用打包保存
    public function save()
    {
        $status = \daicuo\Op::write( input('post.') );
        if( !$status ){
            $this->error(lang('fail'));
        }
        $this->success(lang('success'));
    }    
    
    //卸载应用
    public function delete()
    {
        $event = controller('common/Apply','event');
        if(!$event->uninstall(input('get.module/s'))){
			$this->error(config('daicuo.error'));
		}
        $this->success(lang('success'),'apply/index');
    }
    
    //安装应用
	public function update()
    {
        $event = controller('common/Apply','event');
        if( !$event->install( input('get.module/s') ) ){
            list($error,$module) = config('daicuo.error');
            if($error == 'datatype'){
                $this->error(lang('apply_fail_datatype'), 'apply/store/#database');
            }elseif($error == 'update'){
                $this->error(lang('appName').lang('apply_fail_version'), 'index/index/#update');
            }elseif($error == 'uninstall'){
                $this->error($module.lang('apply_fail_uninstall'), 'apply/store/#'.$module);
            }elseif($error == 'version'){
			    $this->error($module.lang('apply_fail_version'), 'apply/store/#'.$module);
            }elseif($error == 'sql'){
                $this->error($module.lang('apply_fail_sql').'./apps/'.$module.'/event/Sql.php');//执行安装脚本出错
            }else{
                $this->error($module.lang('apply_fail'));//写入插件列表出错
            }
		}
        $this->success(lang('success'));
	}
    
    //应用管理
	public function index()
    {
        $event = controller('common/Apply','event');
		$this->assign('applys', $event->appsInfo());
		return $this->fetch();
	}
    
	//应用市场
	public function store()
    {
		$list = json_decode(DcCurl('auto', 10, lang('appServer').'/store/'),true);
		$this->assign('list', $list);
		return $this->fetch();
	}    
	
}