<?php
// +----------------------------------------------------------------------
// | DaiCuo框架[基于ThinkPHP5.0开发]
// +----------------------------------------------------------------------
// | Copyright (c) 2019-2020 http://www.daicuo.net
// +----------------------------------------------------------------------
// | DaiCuo承诺基础框架永久免费开源，您可用于学习和商用，但必须保留软件版权信息。
// +----------------------------------------------------------------------
// | Author: 老谭 <271513820@qq.com>
// +----------------------------------------------------------------------

namespace app\common\behavior;

class Common
{
    //应用初始化
    public function appInit(&$params){
        //加载缓存配置
        DcLoadConfig('./datas/config/cache.php');
        //加载路由配置
        action('common/Route/appInt','','event');
        //Route::rule('new/:id','home/News/read');
    }
    
    //应用开始
    public function appBegin(&$params){
        //加载框架动态配置
        action('common/Op/appBegin','','event');
        //主域名与移动端域名切换
        action('common/Request/appBegin','','event');
        //注册框架动态钩子
        action('common/Hook/appBegin','','event');
    }
    
    //模块初始化
    public function moduleInit(&$params){
        //获取当前模块名
        $module = request()->module();
        //加载框架所有应用插件信息配置函数等
        action('common/Apply/moduleInit', $module, 'event');
        //后台应用验证
        if('admin' != $module){
            //插件安装验证
            $applys = config('common.site_applys');
            if(!$applys[$module]){
                halt(lang('unInstalled'));
            }
            unset($applys);
            //网站开关验证
            if(config('common.site_status') == 'off'){
                halt(DcHtml(DcEmpty(config('common.site_close'), lang('close'))));
            }
            //多模板主题路径
            config('template.view_path', DcViewPath($module, request()->isMobile()));
        }
    }
    
    /**
     * 配置模块表单验证
     * @param array $data 表单数据（一维数组） 
     * @param string $scene 验证场景(save/update/空)
     * @param bool|array $result 是否直接返回数据(默认false)
     */
    public function opDataValidate(&$params){
        if(false === DcCheck($params['data'], 'common/Op', $params['data']['__scene__'])){
            $params['result'] = false;
		}
    }
    
    /**
     * 钩子模块表单验证
     * @param array $data 表单数据（一维数组） 
     * @param string $scene 验证场景(save/update/空)
     * @param bool|array $result 是否直接返回数据(默认false)
     */
    public function hookDataValidate(&$params){
        if(false === DcCheck($params['data'], 'common/Hook', $params['data']['__scene__'])){
            $params['result'] = false;
		}
    }
    
    /**
     * 路由模块表单验证
     * @param array $data 表单数据（一维数组） 
     * @param string $scene 验证场景(save/update/空)
     * @param bool|array $result 是否直接返回数据(默认false)
     */
    public function routeDataValidate(&$params){
        if(false === DcCheck($params['data'], 'common/Route', $params['data']['__scene__'])){
            $params['result'] = false;
		}
    }
    
    /**
     * 导航模块表单验证
     * @param array $data 表单数据（一维数组） 
     * @param string $scene 验证场景(save/update/空)
     * @param bool|array $result 是否直接返回数据(默认false)
     */
    public function navDataValidate(&$params){
        if(false === DcCheck($params['data'], 'common/Nav', $params['data']['__scene__'])){
            $params['result'] = false;
		}
    }
    
    /**
     * 队列模块表单验证
     * @param array $data 表单数据（一维数组） 
     * @param string $scene 验证场景(save/update/空)
     * @param bool|array $result 是否直接返回数据(默认false)
     */
    public function termDataValidate(&$params){
        if(false === DcCheck($params['data'], 'common/Term', $params['data']['__scene__'])){
            $params['result'] = false;
		}
    }
    
    /**
     * 内容模块表单验证
     * @param array $data 表单数据（一维数组） 
     * @param string $scene 验证场景(save/update/空)
     * @param bool|array $result 是否直接返回数据(默认false)
     */
    public function infoDataValidate(&$params){
        if(false === DcCheck($params['data'], 'common/Info', $params['data']['__scene__'])){
            $params['result'] = false;
		}
    }
    
    /**
     * 用户模块表单验证
     * @param array $data 表单数据（一维数组） 
     * @param string $scene 验证场景(save/update/空)
     * @param bool|array $result 是否直接返回数据(默认false)
     */
    public function userDataValidate(&$params){
        if(false === DcCheck($params['data'], 'common/User', $params['data']['__scene__'])){
            $params['result'] = false;
		}
    }
}